<#macro mainLayout active bodyClass>
<!DOCTYPE html>
<html>
	<head>
		<meta charset="UTF-8">
		<meta name="robots" content="noindex, nofollow">
		<meta http-equiv="X-UA-Compatible" content="IE=edge">
		<meta name="viewport" content="width=device-width, initial-scale=1">
		<title>${msg("accountManagementTitle")}</title>
		<link rel="icon" type="image/png" href="https://www.pirati.cz/assets/favicon/favicon-196x196.png" sizes="196x196">
		<link rel="icon" type="image/png" href="https://www.pirati.cz/assets/favicon/favicon-96x96.png" sizes="96x96">
		<link rel="icon" type="image/png" href="https://www.pirati.cz/assets/favicon/favicon-16x16.png" sizes="16x16">
		<link rel="icon" type="image/png" href="https://www.pirati.cz/assets/favicon/favicon-32x32.png" sizes="32x32">
		<link rel="icon" type="image/png" href="https://www.pirati.cz/assets/favicon/favicon-128.png" sizes="128x128">
        <link href="https://www.pirati.cz/assets/css/main.css" rel="stylesheet">
    <#if properties.styles?has_content>
        <#list properties.styles?split(' ') as style>
        <link href="${url.resourcesPath}/${style}" rel="stylesheet"/>
        </#list>
    </#if>
    <#if properties.scripts?has_content>
        <#list properties.scripts?split(' ') as script>
        <script type="text/javascript" src="${url.resourcesPath}/${script}"></script>
        </#list>
    </#if>
                <!-- <script defer src="https://use.fontawesome.com/releases/v5.0.1/js/all.js"></script> -->
                <script defer src="${url.resourcesPath}/js/fontawesome_all.js"></script>
	</head>
	<body class="admin-console user ${bodyClass}">
		<nav class="navbar">
            <button class="sso-menu-switch"><i class="fa fa-bars"></i></button>
			<header>
				<h1 class="navbar-title"><img src="${url.resourcesPath}/img/logo.svg" alt="Pirátská strana"></h1>
			</header>
			<div class="nav-current">
                <span class="nav-current-item">${(account.firstName!'')} ${(account.lastName!'')} <span class="nav-current-subitem"><#switch account.attributes.type!><#case "member">člen<#break></#switch></span></span>
				<a class="nav-current-item logout" href="${url.logoutUrl}"><i class="fas fa-sign-out-alt"></i></a>
			</div>
			<ul class="nav-links">
				<li class="<#if active=='account'>active</#if>"><a href="${url.accountUrl}">${msg("account")}</a>
				</li>
                <#if features.passwordUpdateSupported>
					<li class="<#if active=='password'>active</#if>"><a href="${url.passwordUrl}">${msg("password")}</a>
					</li></#if>
				<li class="<#if active=='totp'>active</#if>"><a href="${url.totpUrl}">${msg("authenticator")}</a>
				</li>
                <#if features.identityFederation>
					<li class="<#if active=='social'>active</#if>"><a
							href="${url.socialUrl}">${msg("federatedIdentity")}</a></li></#if>
				<li class="<#if active=='sessions'>active</#if>"><a href="${url.sessionsUrl}">${msg("sessions")}</a>
				</li>
				<li class="<#if active=='applications'>active</#if>"><a
						href="${url.applicationsUrl}">${msg("applications")}</a></li>
                <#if features.log>
					<li class="<#if active=='log'>active</#if>"><a href="${url.logUrl}">${msg("log")}</a></li></#if>
			</ul>
            <div class="nav-created-by">Vytvořil <a href="https://michalvasicek.cz">Michal Vašíček</a></div>
		</nav>

		<div class="container">
            <#if message?has_content>
                <div class="alert alert-${message.type}">
                    <#if message.type=='success' ><span class="pficon pficon-ok"></span></#if>
                    <#if message.type=='error' ><span class="pficon pficon-error-octagon"></span><span
							class="pficon pficon-error-exclamation"></span></#if>
                    ${message.summary?no_esc}
				</div>
            </#if>

            <#nested "content">
		</div>

	</body>
</html>
</#macro>
