<#macro registrationLayout bodyClass="" displayInfo=false displayMessage=false>
<!DOCTYPE html>
<html>
    <head>
        <meta charset="UTF-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="robots" content="noindex, nofollow">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title><#nested "title"></title>
        <link rel="icon" href="${url.resourcesPath}/img/favicon.ico"/>
    <#if properties.styles?has_content>
        <#list properties.styles?split(' ') as style>
            <link href="${url.resourcesPath}/${style}" rel="stylesheet"/>
        </#list>
    </#if>
    <#if properties.scripts?has_content>
        <#list properties.scripts?split(' ') as script>
            <script src="${url.resourcesPath}/${script}" type="text/javascript"></script>
        </#list>
    </#if>
    <#if scripts??>
        <#list scripts as script>
            <script src="${script}" type="text/javascript"></script>
        </#list>
    </#if>
        <!-- <script defer src="https://use.fontawesome.com/releases/v5.0.1/js/all.js"></script> -->
        <script defer src="${url.resourcesPath}/js/fontawesome_all.js"></script>
        <style>
         .c-vertical-navigation-items--horizontal .fa-fw { height: 2em; width: 2em; padding: 0.4em; }
        </style>
    </head>

    <body class="${properties.kcBodyClass!}">
        <aside class="o-section o-section--smaller c-header-bar u-inverted u-inverted--darker u-center-860-down">
            <div class="row">
                <div class="o-section-inner" style="padding: 3px;">
                    <div class="medium-12 columns">
                        &nbsp;
                    </div>
                </div>
            </div>
        </aside>
        <div class="c-top-bar">
            <div class="row">
                <div class="c-top-bar-inner u-cf">

                    <div class="top-bar-title">
                        <a href="https://auth.pirati.cz/">
                            <img src="${url.resourcesPath}/img/brand/logo_napis.svg" alt="${realm.displayName}">
                        </a>
                        <span style="display: inline-block; padding: 0.5em 1em 0.5em 3em; font-size:1.15rem; text-transform:uppercase;">
                            ${realm.displayName}
                        </span>
                    </div>
                </div>
            </div>
        </div>
        <div class="c-top-bar-border"></div>
        <div class="page-content">
            <div class="row">
                <div class="medium-12 large-12 large-push-1">
                    <section class="o-section">
                        <h1><#nested "header"></h1>
                    </section>
                </div>
                <div class="medium-12 large-6 large-push-1">
                    <#if message?has_content>
                        <#if message.type = 'success'><div class="sso-message sso-message-success"></#if>
                        <#if message.type = 'warning'><div class="sso-message sso-message-warning"></#if>
                        <#if message.type = 'error'><div class="sso-message sso-message-error"></#if>
                        <#if message.type = 'info'><div class="sso-message sso-message-info"></#if>${message.summary?no_esc}</div>
                    </#if>
                </div>
            </div>
            <div class="row">
                <div id="kc-form" class="${properties.kcFormAreaClass!}">
                    <div id="kc-form-wrapper" class="${properties.kcFormAreaWrapperClass!}">
                    <#nested "form">
                    </div>
                </div>
            </div>
        </div>
        <footer class="o-section o-section--tiled o-section--bigger u-inverted u-cf" style="margin-top:2em">
            <div class="o-section-inner">
                <div class="row">
                    <div class="medium-12 large-3 u-stacked-medium-down columns">
                        <a href="https://www.pirati.cz/portal">
                            <img src="${url.resourcesPath}/img/brand/logo_napis_white.png" style="width: 170px"
                                 alt="Česká pirátská strana" class="u-center-medium-down u-10paddingTop">
                        </a>
                        <p class="u-0margin u-noWrap u-50paddingTop u-smaller-line-height show-for-large">
                            <span class="u-mirror-horizontally">&copy;</span> Piráti, 2018. Všechna práva vyhlazena.
                            <br>
                            <br> Přihlášení vytvořil <!--<a href="https://michalvasicek.cz">-->Michal Vašíček<!--</a>-->.
                    </div>
                    <div class="medium-12 large-7 u-stacked-medium-down columns">
                        <div class="row u-custom-gutter">
                            <div class="small-6 medium-3 columns">
                                <nav class="c-vertical-navigation u-center-medium-only">
                                    <h3 class="c-vertical-navigation__title"><a href="/o-nas/">O nás</a></h3>
                                    <ul class="c-vertical-navigation-items">
                                        <li class="c-vertical-navigation__item">
                                            <a href="https://www.pirati.cz/lide/">Lidé</a>
                                        </li>
                                        <li class="c-vertical-navigation__item">
                                            <a href="https://www.pirati.cz/regiony/">Regiony</a>
                                        </li>
                                        <li class="c-vertical-navigation__item">
                                            <a href="https://www.pirati.cz/program/">Program</a>
                                        </li>
                                        <li class="c-vertical-navigation__item">
                                            <a href="https://www.pirati.cz/volby/2017/">Kandidátky</a>
                                        </li>
                                        <li class="c-vertical-navigation__item">
                                            <a href="https://www.pirati.cz/o-nas/stanovy.html">Stanovy</a>
                                        </li>
                                    </ul>
                                </nav>
                            </div>
                            <div class="small-6 medium-3 columns">
                                <nav class="c-vertical-navigation u-center-medium-only">
                                    <h3 class="c-vertical-navigation__title">Připoj se</h3>
                                    <ul class="c-vertical-navigation-items">
                                        <li class="c-vertical-navigation__item">
                                            <a href="https://www.pirati.cz/pripoj-se/">Dej nám vedět</a>
                                        </li>
                                        <li class="c-vertical-navigation__item">
                                            <a href="https://www.pirati.cz/feed.xml">RSS / Atom feed</a>
                                        </li>
                                        <li class="c-vertical-navigation__item">
                                            <a href="https://www.pirati.cz/download">Ke stažení</a>
                                        </li>

                                    </ul>
                                </nav>
                            </div>
                            <div class="small-6 medium-3 u-mobile-down-clear columns">
                                <nav class="c-vertical-navigation u-center-medium-only">
                                    <h3 class="c-vertical-navigation__title">Makáme</h3>
                                    <ul class="c-vertical-navigation-items">
                                        <li class="c-vertical-navigation__item">
                                            <a href="https://www.pirati.cz/aktuality/">Aktuality</a>
                                        </li>
                                        <li class="c-vertical-navigation__item">
                                            <a href="https://www.pirati.cz/pripoj-se/kalendar/">Kalendář</a>
                                        </li>
                                    </ul>
                                </nav>
                            </div>
                            <div class="small-6 medium-3 columns">
                                <nav class="c-vertical-navigation u-center-medium-only">
                                    <h3 class="c-vertical-navigation__title"><a href="/otevrenost/">Otevřenost</a></h3>
                                    <ul class="c-vertical-navigation-items">
                                        <li class="c-vertical-navigation__item">
                                            <a href="https://ucet.pirati.cz">Transparentní účet</a>
                                        </li>
                                        <li class="c-vertical-navigation__item">
                                            <a href="https://smlouvy.pirati.cz">Registr smluv</a>
                                        </li>
                                        <li class="c-vertical-navigation__item">
                                            <a href="https://wiki.pirati.cz/fo/otevrene_ucetnictvi">Otevřené
                                                účetnictví</a>
                                        </li>
                                        <li class="c-vertical-navigation__item">
                                            <a href="https://goo.gl/W3Mx9H">Informace o dárcích</a>
                                        </li>
                                    </ul>
                                </nav>
                            </div>
                        </div>
                    </div>
                    <div class="medium-12 large-2 u-stacked-medium-down columns u-center-medium-down">
                        <nav class="c-vertical-navigation">
                            <h3 class="c-vertical-navigation__title">Buďte s námi v síti</h3>
                            <ul class="c-vertical-navigation-items c-vertical-navigation-items--horizontal">
                                <li class="c-vertical-navigation__item">
                                    <a href="https://www.facebook.com/ceska.piratska.strana/" rel="noopener noreferrer"
                                       title="Facebook - Česká pirátská strana">
                                        <i class="fab fa-fw fa-facebook-f c-icon c-icon--rounded c-icon--facebook"
                                           aria-hidden="true"></i>
                                    </a>
                                </li>
                                <li class="c-vertical-navigation__item">
                                    <a href="https://www.twitter.com/PiratskaStrana" rel="noopener noreferrer"
                                       title="Twitter - Česká pirátská strana">
                                        <i class="fab fa-fw fa-twitter c-icon c-icon--rounded c-icon--twitter"
                                           aria-hidden="true"></i>
                                    </a>
                                </li>
                                <li class="c-vertical-navigation__item">
                                    <a href="https://www.instagram.com/pirati.cz/" rel="noopener noreferrer"
                                       title="Instagram - Česká pirátská strana">
                                        <i class="fab fa-fw fa-instagram c-icon c-icon--rounded c-icon--instagram"
                                           aria-hidden="true"></i>
                                    </a>
                                </li>
                                <li class="c-vertical-navigation__item">
                                    <a href="https://plus.google.com/+piratskastrana" rel="noopener noreferrer"
                                       title="Google Plus - Česká pirátská strana">
                                        <i class="fab fa-fw fa-google-plus c-icon c-icon--rounded c-icon--googlePlus"
                                           aria-hidden="true"></i>
                                    </a>
                                </li>
                            </ul>
                        </nav>
                        <p class="u-10paddingTop u-maxWidth80percent u-smaller-line-height hide-for-large">
                            <span class="u-mirror-horizontally">&copy;</span> Piráti, 2016. Všechna práva vyhlazena.
                            <br>
                            <br> Přihlášení vytvořil <!--<a href="https://michalvasicek.cz">-->Michal Vašíček<!--</a>-->.
                    </div>
                </div>
            </div>
        </footer>
        <aside class="o-section o-section--bigger c-contact-bar u-inverted u-center-medium-down">
            <div class="o-section-inner">
                <div class="row">
                    <div class="small-12 columns">
                        <header class="c-contact-bar-header u-stacked-medium-down">
                            <h3 class="c-contact-bar__heading"><a href="https://www.pirati.cz/kontakt/">Kontakt</a></h3>
                        </header>
                        <ul class="c-contact-bar-items u-stacked-medium-down">
                            <li class="c-contact-bar__item u-stacked-medium-down">
                                <div class="c-contact-bar__section"> Aplikaci spravuje</div>
                                <div class="c-contact-bar__description"> Martin Rejman
                                </div>
                            </li>
                        </ul>
                    </div>
                </div>
            </div>
        </aside>
    </body>
</html>
</#macro>
